"""
 Vehicle
"""
from algorithm.core.Shipment import Shipment


class Vehicle:
    def __init__(self, id, max_capacity):
        self.id = id
        self.max_capacity = max_capacity
        self.capacity = 0
        self.route = []

    def add_location(self, location_id):
        self.route.append(Shipment(location_id, 0))

    def add_shipment(self, location):
        if self.capacity + location.capacity <= self.max_capacity:
            self.route.append(Shipment(location.id, location.capacity))
            self.capacity += location.capacity
            return True, location.capacity
        else:
            loaded_capacity = self.max_capacity - self.capacity
            if loaded_capacity != 0:
                self.route.append(Shipment(location.id, loaded_capacity))
                self.capacity += loaded_capacity
                return True, loaded_capacity
            else:
                return False, 0
