from algorithm.core.Location import Location
from algorithm.core.Problem import VehicleRoutingProblem
import json

from algorithm.core.Vehicle import Vehicle


def parse_json(data, vrp):
    nodes = data["nodes"]

    for node in nodes:
        vrp.add_location(Location(node["id"], node["capacity"], node["parent_id"]))

    for i in range(1, 100):
        vrp.add_vehicle(Vehicle(i, 50))


vrp = VehicleRoutingProblem()

parse_json(json.load(open("data/tree.json", "r")), vrp)

vrp.solve4()
