import sys
import math

# Auto-generated code below aims at helping you parse
# the standard input according to the problem statement.

number_mine_spots = int(input())
for i in range(number_mine_spots):
    x, y = [int(j) for j in input().split()]


def get_neighbours(sell):
    res = []
    if sell[0] - 1 >= 0:
        res.append((sell[0] - 1, sell[1]))
    if sell[0] + 1 < 12:
        res.append((sell[0] + 1, sell[1]))
    if sell[1] - 1 >= 0:
        res.append((sell[0], sell[1] - 1))
    if sell[1] + 1 < 12:
        res.append((sell[0], sell[1] + 1))
    return res


def calculate_neighbours(my_active_sells, enemy_sells, void_sells, my_sells):
    all_nb = []
    for sell in my_active_sells:
        all_nb.extend(get_neighbours(sell))
    can_move_sells = list(set(all_nb) - set(enemy_sells) - set(void_sells) - set(my_sells))
    return can_move_sells


def get_points_roles(map):
    my_sells = []
    my_active_sells = []
    available_sells = []
    enemy_sells = []
    enemy_active_sells = []
    void_sells = []
    for j, line in enumerate(map):
        for i, sell in enumerate(line):
            if sell == '.':
                available_sells.append((i, j))
            elif sell == 'o':
                my_sells.append((i, j))
            elif sell == 'O':
                my_sells.append((i, j))
                my_active_sells.append((i, j))
            elif sell == '#':
                void_sells.append((i, j))
            elif sell == 'x':
                enemy_sells.append((i, j))
            elif sell == 'X':
                enemy_sells.append((i, j))
                enemy_active_sells.append((i, j))
    return my_sells, my_active_sells, available_sells, enemy_sells, enemy_active_sells, void_sells


def calc_dist(sell1, sell2):
    return abs(sell1[0] - sell2[0]) + abs(sell1[1] - sell2[1])


def if_enemy_nearby(enemy_active_sells, my_buildings):
    danger = 0
    for sell in enemy_active_sells:
        for build in my_buildings:
            if calc_dist(sell, build) < 4:
                danger += 1
    return danger


# game loop
while True:
    gold = int(input())
    income = int(input())
    opponent_gold = int(input())
    opponent_income = int(input())
    map = []
    for i in range(12):
        line = input()
        map.append(line)
    building_count = int(input())
    my_buildings = []
    enemy_buildings = []
    for i in range(building_count):
        owner, building_type, x, y = [int(j) for j in input().split()]
        if owner == 0:
            my_buildings.append((x, y))
        else:
            enemy_buildings.append((x, y))
    unit_count = int(input())
    my_units = {}
    enemy_units = {}
    for i in range(unit_count):
        owner, unit_id, level, x, y = [int(j) for j in input().split()]
        if owner == 0:
            my_units[unit_id] = {'coord': (x, y), 'level': level}
        else:
            enemy_units[unit_id] = {'coord': (x, y), 'level': level}

    my_sells, my_active_sells, available_sells, enemy_sells, enemy_active_sells, void_sells = get_points_roles(map)

    # Write an action using print
    # To debug: print("Debug messages...", file=sys.stderr)
    can_move_sells = calculate_neighbours(my_active_sells, enemy_sells, void_sells, my_sells)

    neigb_build = sorted(get_neighbours(my_buildings[0]))

    sell_for_units = neigb_build[0]
    sell_for_defense = neigb_build[1]
    command = ''

    danger = if_enemy_nearby(enemy_active_sells, my_buildings)
    if danger:
        command += 'TRAIN {} {} {};'.format(2, sell_for_defense[0], sell_for_defense[1])

    defense_ids = [id for id in my_units.keys() if my_units[id]['level'] == 2]

    attack_enemy_sells = set(enemy_active_sells).intersection(set(get_neighbours(my_units[defense_ids[0]['coord']])))
    if attack_enemy_sells:
        command += 'MOVE {} {} {};'.format(defense_ids[0], attack_enemy_sells[0][0], attack_enemy_sells[0][1])

    units_closest = {}
    for unit_id in my_units:
        min_dist_sell = sorted(can_move_sells, key=lambda sell: calc_dist(my_units[unit_id]['coord'], sell))
        units_closest[unit_id] = (min_dist_sell[0], calc_dist(my_units[unit_id]['coord'], min_dist_sell[0]))

    if not my_units:
        print('TRAIN {} {} {}'.format(1, sell_for_units[0], sell_for_units[1]))
    else:
        unit_id = my_units[0]
        if gold > 10 * len(my_units) and 'TRAIN' not in command:
            command += 'TRAIN {} {} {};'.format(1, sell_for_units[0], sell_for_units[1])
        for unit_id in my_units:
            command += 'MOVE {} {} {};'.format(unit_id, units_closest[unit_id][0][0], units_closest[unit_id][0][1])
        print(command, file=sys.stderr)
        print(command)

